SystemOrganization addCategory: #Everett!

Object subclass: #EntityManager
	instanceVariableNames: 'nextAvailableEntity entityTable entityTags changedEntities removedEntities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 18:17'!
addComponent: aComponentInstance To: anEntity

	(anEntity < nextAvailableEntity and: anEntity >= 0) ifTrue: 
	[  
		self atEntity: anEntity putComponent: aComponentInstance.
	]! !

!EntityManager methodsFor: 'private' stamp: 'EricShahkarami 6/27/2013 18:23'!
atEntity: anEntity putComponent: aComponentInstance 
		
	(entityTable at: anEntity) at: (aComponentInstance identity) put: aComponentInstance. ! !

!EntityManager methodsFor: 'accessing' stamp: 'EricShahkarami 6/28/2013 12:15'!
component: aComponentIdentifier from: anEntity! !

!EntityManager methodsFor: 'private' stamp: 'EricShahkarami 6/28/2013 12:07'!
componentsOfEntity: anEntity

	^(entityTable at: anEntity).
! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:09'!
createEntity

	entityTable at: nextAvailableEntity put: (Dictionary new).	
	nextAvailableEntity = nextAvailableEntity + 1.
	^(nextAvailableEntity - 1)
! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:10'!
createEntityFromTag: aTag
	"Create a replica of a tagged entity"! !

!EntityManager methodsFor: 'accessing' stamp: 'EricShahkarami 6/27/2013 16:30'!
entitiesMatching: aComponentExpression! !

!EntityManager methodsFor: 'initialize-release' stamp: 'EricShahkarami 6/28/2013 12:11'!
initialize 
	
	super initialize.
	entityTable := Dictionary new.
	entityTags := Dictionary new! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:16'!
removeComponent: aComponentIdentifier from: anEntity! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 16:27'!
removeEntity: anEntity! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 14:12'!
removeTag: aTag! !

!EntityManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:13'!
tag: anEntity with: aTag! !

Object subclass: #EverettComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!EverettComponent class methodsFor: 'instance creation' stamp: 'EricShahkarami 6/27/2013 13:52'!
identity
	^self subclassResponsibility! !

Object subclass: #EverettSystem
	instanceVariableNames: 'updateInterval matchingEntities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!EverettSystem class methodsFor: 'instance creation' stamp: 'EricShahkarami 6/27/2013 14:20'!
identity
	^self subclassResponsibility ! !

!EverettSystem class methodsFor: 'instance creation' stamp: 'EricShahkarami 6/27/2013 16:26'!
updateInterval: anUpdateInterval
	^(self new updateInterval: anUpdateInterval)! !

!EverettSystem methodsFor: 'processing' stamp: 'EricShahkarami 6/27/2013 16:08'!
updateEntitiesOf: anEntityManager afterTimeDelta: dt! !

!EverettSystem methodsFor: 'processing' stamp: 'EricShahkarami 6/27/2013 16:27'!
updateEntity: anEntity afterTimeDelta: dt! !

!EverettSystem methodsFor: 'initialize-release' stamp: 'EricShahkarami 6/27/2013 16:26'!
updateInterval: anUpdateInterval
	updateInterval := anUpdateInterval ! !

Object subclass: #SystemManager
	instanceVariableNames: 'systems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Everett'!

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 14:16'!
addSystem: aSystemInstance 
	! !

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/27/2013 16:12'!
addSystem: aSystem withPriority: aPriority! !

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:15'!
assignSystem: aSystemIdentifier aPriorityOf: aPriority! !

!SystemManager methodsFor: 'create-modify-destroy' stamp: 'EricShahkarami 6/28/2013 12:15'!
removeSystem: aSystemIdentifier! !

!SystemManager methodsFor: 'processing' stamp: 'EricShahkarami 6/27/2013 16:08'!
updateEntitiesOf: anEntityManager afterTimeDelta: dt! !
